Program Quake_Cleaner;

{----------------------------------------------------------------------}
{ QUAKE CLEANER                                                        }
{----------------------------------------------------------------------}
{ THE ULTIMATE ONE.... TAKES QCONSOLE.LOG AND DOES THE LOT!!!!         }
{ Limitations:-														   }
{ (1) The qconsole.log should've come from a dedicated server yielding }
{     messages like Mr-Pink entered the game/left the game with 8 frags}
{----------------------------------------------------------------------}
Const max_players = 32; {Max players in a session that can be coped with}
						{Max i've ever seen is 14 but....}
VAR	Read_File, Write_file					: TEXT;
    Input_Log_File_Name, basic_file_name  	: STRING;
	Output_file_name,temp_file_name			: STRING;
	config_file_name						: STRING;
	line_of_file,temp_string				: STRING;
	Read_File_OK, times_found				: BOOLEAN;
    line_count,num_slots_left				: INTEGER;
	conv_code, num_player 					: INTEGER;
	num_player_str 							: STRING[2];
    i,j,k,line_length,dummy,temp_int		: INTEGER;
    player_name,score_str,rank_str			: STRING;
    eff_str									: STRING;
	num_words_in_line						: INTEGER;
	killer_name, victim_name				: STRING;
	killer_row, victim_col					: INTEGER;
	kill_type								: CHAR;
	html_mode,comma_mode,full_mode 			: BOOLEAN;
	debug_mode								: BOOLEAN;	{If true it will print tables to screen}
	player_not_in_array						: BOOLEAN;
	start_of_line 							: STRING;
	garbage_line							: BOOLEAN;
	
	{this lot for the textrep tool}
	first_char								: CHAR;
	line_num,changes_made,num_changes		: INTEGER;
	comma_posn,num_changes_to_make			: INTEGER;
	From_array, To_array 					:	ARRAY[1..max_players] of STRING;
	change_posn_array						:	ARRAY[1..2] of INTEGER;
	player_to_change_array					:	ARRAY[1..2] of INTEGER;			
	player_name_from,player_name_to			:	STRING;
	first_character							:	CHAR;
	
Type player_stats =	RECORD
						name 		: STRING;
						frags		: INTEGER;
						deaths		: INTEGER;
						rank		: INTEGER;
						eff			: INTEGER;
						start		: INTEGER;
						endtime 	: INTEGER;
						game_time   : INTEGER;
						game_time_str : STRING;
						suicides	: INTEGER;
						axe_kill	: INTEGER;
						axe_death	: INTEGER;
						shot_kill	: INTEGER;
						shot_death	: INTEGER;
						nail_kill	: INTEGER;
						nail_death	: INTEGER;
						rock_kill	: INTEGER;
						rock_death	: INTEGER;
						light_kill	: INTEGER;
						light_death	: INTEGER;
						tele_kill	: INTEGER;
						tele_death	: INTEGER;
						pipe_kill	: INTEGER;
						pipe_death	: INTEGER;
						frags_min	: REAL;
					END;

Var	player_array : ARRAY[1..max_players] Of player_stats;

Var kill_death_array : ARRAY[1..max_players,1..max_players] Of INTEGER;

Var out_str : ARRAY[1..22] of STRING[13];

{-----------------------------Start of Procedures-------------------------------------}
	Procedure reset_players;
	Var a,b : INTEGER;
	Begin
		For a := 1 to max_players Do
			Begin
				player_array[a].name := 'XXX';			player_array[a].frags := 0;
				player_array[a].deaths := 0;			player_array[a].rank := 0;
				player_array[a].eff := 0;				player_array[a].start := 0;
				player_array[a].endtime := 0;			player_array[a].game_time := 0;								
				player_array[a].game_time_str := '';	player_array[a].suicides := 0;
				player_array[a].axe_kill := 0;			player_array[a].axe_death := 0;
				player_array[a].shot_kill := 0;			player_array[a].shot_death := 0;
				player_array[a].nail_kill := 0;			player_array[a].nail_death := 0;
				player_array[a].rock_kill := 0;			player_array[a].rock_death := 0;
				player_array[a].light_kill := 0;		player_array[a].light_death := 0;
				player_array[a].tele_kill := 0;			player_array[a].tele_death := 0;
				player_array[a].pipe_kill := 0;			player_array[a].pipe_death := 0;
				player_array[a].frags_min := 0.0;		
				For b:= 1 to max_players Do
					kill_death_array[a,b] := 0;
			End;{for}
			
			out_str[1] := 'Player:      ';		out_str[2] := 'Frags:       ';
			out_str[3] := 'Deaths:      ';		out_str[4] := 'Rank:        ';
			out_str[5] := 'Eff%:        ';		
			out_str[6] := 'Suicides:    ';		out_str[7] := 'Axe-Kill:    ';
			out_str[8] := 'Shot-Kill:   ';		out_str[9] := 'Nail-Kill:   ';
			out_str[10] := 'Rock-Kill:   ';		out_str[11] := 'Light-Kill:  ';
			out_str[12] := 'Tele-Kill:   ';		out_str[13] := 'Pipe-Kill:   ';
			out_str[14] := 'Axe-Death:   ';		out_str[15] := 'Shot-Death:  ';
			out_str[16] := 'Nail-Death:  ';		out_str[17] := 'Rock-Death:  ';
			out_str[18] := 'Light-Death: ';		out_str[19] := 'Tele-Death:  ';
			out_str[20] := 'Pipe-Death:  ';		out_str[21] := 'Time:        ';
			out_str[22] := 'Frags/Min:   ';

			For a:= 1 to max_players Do
				Begin
					From_array[a] := '';
					To_array[a] := '';	
				End;
			change_posn_array[1] :=  0;
			change_posn_array[2] :=  0;
			player_to_change_array[1] :=0; 
			player_to_change_array[2] :=0; 
			line_num:=1;
			changes_made :=0;	num_changes:= 1;

	End;{proc}
	
	
	Procedure SimplifyDelimiters(Var TokenList : String;Delimiters : String);       
	Var DelTel  : Byte;                                                             
	Begin                                                                           
		DelTel:=1;                                                                      
		Repeat                                                                          
			If (Pos(TokenList[DelTel],Delimiters)>0) And                                    
			   (Pos(TokenList[DelTel+1],Delimiters)>0)                                      
	   		Then Delete(TokenList,DelTel,1)                                              
	   		Else Inc(DelTel);                                                            
		Until DelTel>=(Length(TokenList)-1);                                            
	End;                                                                            

	Procedure DeleteTrailingSpaces(Var TokenList : String);                         
	Var Tel : Byte;                                                                 
	Begin                                                                           
		Tel:=Length(TokenList);                                                         
		While (Tel>0) And (TokenList[Tel]=' ') Do                                       
			Dec(Tel);                                                                      
			TokenList[0]:=Chr(Tel);                                                         
	End;                                                                            

	Procedure SkipLeadingSpaces(Var TokenList : String);                            
	Var Tel : Byte;                                                                 
	Begin                                                                           
		Tel:=1;                                                                         
		While (Tel<=Length(TokenList)) And (TokenList[Tel]=' ') Do                      
			Inc(Tel);                                                                      
			Delete(TokenList,1,Tel-1);                                                      
	End;                                                                            


	Procedure Remove_last_chars(Var input_string: STRING; num_chars: INTEGER);
	Var str_length : INTEGER;
	Begin
		str_length := LENGTH(input_string);
		DELETE(input_string,str_length-num_chars+1,num_chars);	{take last chars off}
	End;

	Function Get_word(Var textline : String; word_number : INTEGER):String;          
	Var space_posn 											: ARRAY[1..16] Of INTEGER;
		space_count_ptr, line_length, i, posn_from, posn_to	: INTEGER;
		char_read											: CHAR;
		temp_str											: STRING;
				
	Begin                                                                           
		space_count_ptr := 0;
		For i := 1 to 16 Do space_posn[i] := 0;
		line_length := LENGTH(textline);	{ Get line length}
		For i := 1 to line_length Do		{ Check each Char in line for a space }
			Begin
				char_read := textline[i];
				If (char_read = ' ') then
					Begin
						space_count_ptr := space_count_ptr + 1;
						space_posn[space_count_ptr] := i;	
					End;
			End;
		space_posn[space_count_ptr + 1] := line_length; {extra one is for last word in line}

		{we now have an array space_posn with values of where the spaces are!}
		{DEBUG	For i := 1 to 16 Do Write(space_posn[i],' '); }

		If (word_number = 1) Then
			Get_word := COPY(textline,1,space_posn[1])
		Else
			Begin
				posn_from := space_posn[word_number-1]+1;
				posn_to := (space_posn[word_number] - space_posn[word_number-1]);
				temp_str := COPY(textline,posn_from, posn_to); 
				{DEBUG	Writeln('Word: ',word_number,' :    From: ', posn_from,'   To: ',posn_to,' -> ',temp_Str); }
				Get_word := temp_str;
			End;
	{DEBUG Readln; }
	End; {fn}

	Procedure Update_player_scores(Var kill_type : STRING; weapon: CHAR);
	Begin
		If (kill_type='KILL') then
		Begin
			For k:= 1 to num_player Do
				Begin
				If (killer_name=player_array[k].name) Then
					Begin
						player_array[k].frags := player_array[k].frags+1;
						killer_row := k;
						case weapon of
						'N'	: player_array[k].nail_kill := player_array[k].nail_kill+1;
						'S'	: player_array[k].shot_kill := player_array[k].shot_kill+1;
						'A'	: player_array[k].axe_kill := player_array[k].axe_kill+1;
						'T'	: player_array[k].tele_kill := player_array[k].tele_kill+1;
						'R'	: player_array[k].rock_kill := player_array[k].rock_kill+1;
						'L'	: player_array[k].light_kill := player_array[k].light_kill+1;
						'P'	: player_array[k].pipe_kill := player_array[k].pipe_kill+1;
						End;{case}
					End;
				If (victim_name=player_array[k].name) then
					Begin
						player_array[k].deaths := player_array[k].deaths+1;
						victim_col := k;
						case weapon of
						'N'	: player_array[k].nail_death := player_array[k].nail_death+1;
						'S'	: player_array[k].shot_death := player_array[k].shot_death+1;
						'A'	: player_array[k].axe_death := player_array[k].axe_death+1;
						'T'	: player_array[k].tele_death := player_array[k].tele_death+1;
						'R'	: player_array[k].rock_death := player_array[k].rock_death+1;
						'L'	: player_array[k].light_death := player_array[k].light_death+1;
						'P'	: player_array[k].pipe_death := player_array[k].pipe_death+1;
						End;{case}
					End;
			End;{for}
		End
		Else
		If (kill_type='SUICIDE') then
		Begin
			For k:= 1 to num_player Do
				If (killer_name=player_array[k].name) Then
					Begin
						player_array[k].frags := player_array[k].frags-1;
						player_array[k].suicides := player_array[k].suicides+1;
						killer_row := k;
						victim_col := killer_row;
					End; {if}
		End{if-else etc}		
		Else
			Writeln('I do not understand: <',kill_type,'>');
		{update the kill in the 2D-array}
		kill_death_array[killer_row, victim_col] := kill_death_array[killer_row, victim_col] +1;
	End;{proc}


	Function count_words(input_line:STRING): INTEGER;
	Var line_length, loop, space_count : INTEGER;
	Begin
		line_length := LENGTH(input_line);
		space_count := 0;
		For loop := 1 to line_length Do
			if (input_line[loop]=' ') then {count spaces}
				space_count := space_count+1;

		count_words := space_count;
	End;{fn}

	Function hours_mins_secs(secs: INTEGER): STRING;
	Var mins, hours 					: INTEGER;
	    mins_str,secs_str, hours_str 	: STRING[2];
	Begin
		mins := 0;		
		hours := 0;
		
		Case secs Of
		0..59 : 	Begin
						STR(secs,secs_str);
						hours_mins_secs := CONCAT(secs_str,'s');
					End;
		60..3599 : 	Begin
						mins := secs div 60;	
						secs := secs mod 60;
						STR(secs,secs_str);
						STR(mins,mins_str);
						hours_mins_secs := CONCAT(mins_str,'m ',secs_str,'s');
					End;
		3600..9999: Begin
						mins := secs div 60;	
						secs := secs mod 60;
						hours := mins div 60;
						mins := mins mod 60;
						STR(secs,secs_str);
						STR(mins,mins_str);
						STR(hours,hours_str);
						hours_mins_secs := CONCAT(hours_str,'h ',mins_str,'m ',secs_str,'s');
					End;
		else		
			hours_mins_secs := 'Error: Time TOO long?';  {return value}
		End;{case}
	End; {fn}

	Procedure Print_banner;
	Begin
		Writeln('ͻ');
		Writeln(' Quake Cleaner V1.1 ---------By: M.Bell 1997 ');
		Writeln('ͼ');
	End;{proc}


	Procedure  check_if_player_is_in_array(Var tmp_name : STRING);
	Var loop : INTEGER;
	begin
		player_not_in_array := FALSE;
		if (num_player=0) then
			begin
			player_array[1].name := tmp_name;
			if (debug_mode) then writeln('Player: ',tmp_name,' added! -> ', num_player);
			num_player := 1;
			end
		else
		if (debug_mode) then writeln('Searching range 1 to ',num_player+1);
		if (debug_mode) then Writeln('For player: ', temp_string);
		for loop := 1 to num_player+1 do
			begin
			if (debug_mode) then write(loop, ' Comparing:',tmp_name,': with :',player_array[loop].name,':');
				if ( (tmp_name <> player_array[loop].name) ) then
				begin
					player_not_in_array := TRUE;
					if (debug_mode) then writeln(' <- NO');
				end
				else
					begin  {player already in array}
					player_not_in_array := FALSE;	
					if (debug_mode) then writeln(' <- MATCH');
					exit;  {if player is found exit the procedure now.....}
					end;			
			end;
		if (debug_mode) then writeln;
	end; {proc}


{-----------------------------------------------------------------------------------------}
{--------------------------------------MAIN-----------------------------------------------}
{-----------------------------------------------------------------------------------------}
BEGIN

{-------------------}
{ SECTION 1 - SETUP }
{-------------------}
        line_count := 0;				dummy := 0;
		reset_players;					num_player :=0;
		times_found := FALSE;			num_slots_left := max_players;
		html_mode := FALSE;
		comma_mode := FALSE;
		full_mode := FALSE;
		debug_mode := FALSE;  {TRUE;  }
		
		temp_file_name := 'tmp.out';
		config_file_name	:= 'qclean.cfg';


			{ FILE IO SETUP }
			If (ParamStr(1) = '/?') OR
           	   (ParamStr(1) = '?') OR
               (ParamStr(1) = 'help') Then

           BEGIN
				Print_banner;
				Writeln;
				Writeln('        qclean <inputfile.log> options'); Writeln;
				Writeln('Options:');
				Writeln('         -html  : Produce a html document');
				Writeln('         -comma : Produce a comma-delimited document');
				Writeln('         -full  : Produce Comprehensive stats'); 
				Writeln('         -debug : Produce Stuff on screen'); Writeln;				
				Writeln('Default is <qconsole.log> and no options');	Writeln;
				Writeln('Notes:');
				Writeln('      Uses a standard Quake qconsole.log file from a dedicated server');
				Writeln('      or a client connection.');
				Writeln('      Input file should be 8 characters long or less.');
				Writeln('      Output will be <inputfile>.txt/htm/dat depending on options.');
				Writeln('      Ensure that a qclean.cfg file with names to alter exists.');
                Halt;
           END;

        If (ParamStr(1) <> '') then
            Input_Log_File_Name := ParamStr(1)
        Else
            Input_Log_File_Name := 'qconsole.log';	{default}

		temp_int := LENGTH(Input_Log_File_Name);
		Basic_file_name := Input_Log_File_Name;
		DELETE(Basic_file_name,temp_int-2,3);
		{Basic_file_name will now be 'qconsole.'}

		For i:= 2 to ParamCount Do
			Begin
				if (ParamStr(i)='-html') then
					html_mode := TRUE;
				if (ParamStr(i)='-comma') then
					comma_mode := TRUE;
				if (ParamStr(i)='-full') then
					full_mode := TRUE;
				if (ParamStr(i)='-debug') then
					debug_mode := TRUE;					
			End;

		Print_banner;


{---------------------------------------------------------------------}
{ SECTION 2 - Read in config-file with list of player names to change }
{---------------------------------------------------------------------}
	Assign(Read_File,config_file_name);

    {$I-}   Reset(Read_File);   {$I+}
    Read_File_OK := (IOResult = 0);

     if (Read_File_OK) then
     Begin
		While not Eof(Read_File) Do
       	Begin
       		Readln(Read_File, line_of_file);		{Get line}
			first_char := line_of_file[1];
			
			if (line_num=1) then
				if (line_of_file<>'QCLEAN_CONFIG_FILE') then
				Begin
					Writeln('Invalid Config file: Read: ',line_of_file,' ',line_num);
					Halt;
				End;
			
			if (line_num<>1) then
				Begin
					if (first_char<>';') then {NOT a comment line}
					Begin
						comma_posn := POS('',line_of_file);
						line_length := LENGTH(line_of_file);
						From_array[num_changes] := COPY(line_of_file,1,comma_posn-1);
						To_array[num_changes] := COPY(line_of_file,comma_posn+1, line_length-comma_posn+1);
						if (debug_mode) then
							Writeln(line_num,' : ',line_length,' ',comma_posn,' ',  line_of_file,
			  					' ->',From_array[line_num-1],'<- ->',To_array[line_num-1],'<-');		
						num_changes := num_changes +1;
					End; {if 1st}
				End; {line<>1}
				line_num := line_num+1;
		End;{while}
		Close(Read_File);  {config File}
		num_changes := num_changes-1;	
		Writeln('Looking for ',num_changes,' dodgy Player-names...'); 
	End {readfile_ok}		
	Else
	Begin
		Writeln('Can''t find Config file <qclean.cfg>, execution aborted');
        Halt;
    End;

{---------------------------------------------------------------------}
{ SECTION 3 - Read in qconsole.log file and generate  a temp-file as  }
{             output that has players-hyphenated & crud-lines deleted }
{---------------------------------------------------------------------}
	Writeln('-----------------------------------------------');
	Writeln('Reading input File:- ', Input_log_File_Name);
	Assign(Read_File,Input_log_File_Name);
	Writeln('Writing Temp File:- ', temp_File_Name);
    Assign(Write_File, temp_File_Name);
    Rewrite(Write_File);                {creates a new file}

    {$I-}   Reset(Read_File);   {$I+}
    Read_File_OK := (IOResult = 0);

     if (Read_File_OK) then
     Begin
		line_num:=0;

		While not Eof(Read_File) Do
       	Begin
       		Readln(Read_File, line_of_file);		{Get line}

			start_of_line := COPY(line_of_file,1,8);
			first_character := line_of_file[1];
 		    if	(start_of_line = 'You get ') OR
 		      	(start_of_line = 'You got ') OR
         	    (start_of_line = 'You rece') OR
                (start_of_line = 'Ring of ') OR
                (start_of_line = 'backup p') OR
                (start_of_line = 'not enou') OR
                (start_of_line = 'no weapo') OR
                (start_of_line = 'Console ') OR
				(start_of_line = 'IPX init') OR
				(start_of_line = 'Serial d') OR
				(start_of_line = 'Sound In') OR
				(start_of_line = 'Sound sa') OR
				(start_of_line = 'CD Audio') OR
				(start_of_line = 'execing ') OR
				(start_of_line = 'IPX driv') OR
				(start_of_line = 'VERSION ') OR
				(start_of_line = '--> clie') OR
				(start_of_line = 'Unknown ') OR
				(start_of_line = 'Quad Dam') OR
				(start_of_line = 'Protecti') OR
				(start_of_line = 'Air supp') OR
				(start_of_line = 'Gravity ') OR
				(start_of_line = 'Max jump') OR
				(start_of_line = 'Level ju') OR
				(start_of_line = 'Max gren') OR
				(start_of_line = 'inverse ') OR
				(start_of_line = 'Bot shou') OR
				(start_of_line = 'Couldn''t') OR
				(line_of_file = '')	OR 
				(first_character < 'A') OR
				(first_character > 'z') OR	
				((first_character < 'a') AND (first_character > 'Z')) then
				garbage_line := TRUE
			else
				garbage_line := FALSE;

			line_num := line_num + 1;
			num_changes_to_make := 0;

			{Search the line for the strings and output three things:-
			 (1) num_changes_to_make : 1 or 2 per line
			 (2) change_posn_array[1..2] for the posn of the changes
			 (3) player_to_change_array[1..2] for the player to change}
			For i:= 1 to num_changes Do
			Begin
				temp_int := POS(From_array[i], line_of_file); 
				if (temp_int <> 0) then 
				Begin
					num_changes_to_make := num_changes_to_make+1;
					change_posn_array[num_changes_to_make] := temp_int;
					player_to_change_array[num_changes_to_make] := i;
				if (debug_mode) then
					Begin
					Writeln('Line: ',line_num,' Player: ',From_array[i],' <',line_of_file,'>');
					Write('     Must Make: ',num_changes_to_make,' changes');
					For k:= 1 to num_changes_to_make Do
						Begin
						Write(' at: ',change_posn_array[k]);
						Write(' 4Player: ',player_to_change_array[k]);						
						End;
					Writeln;					
					End;{debug}
				End;
			End;{for}

			For i:= 1 to num_changes_to_make Do
			Begin
				if (debug_mode) then
					writeln(num_changes_to_make,': <',line_of_file,'>');
				player_name_from := From_array[player_to_change_array[i]];
				player_name_to := To_array[player_to_change_array[i]];
				line_length := LENGTH(player_name_from);

				if (debug_mode) then
					writeln(player_to_change_array[i],' ->',player_name_from,'<--->',player_name_to,'<- ',line_length);

				temp_int := change_posn_array[i];

				{remove the old player name}
				DELETE(line_of_file,temp_int,line_length); {WAS line_length-temp_int+1}
				if (debug_mode) then
					writeln('DELETING: ',line_length,' chars from posn: ',temp_int,' ->',line_of_file,'<-');
			   	INSERT(To_array[player_to_change_array[i]],line_of_file,temp_int);	
				if (debug_mode) then
					writeln('INS: ',line_of_file);
				changes_made := changes_made+1;
			End;{for}

			if (garbage_line=FALSE) then
				begin
				if (debug_mode) then Writeln('Good line =>',line_of_file,'<=');
				Writeln(write_file, line_of_file)    {write the line out!!}
				end
			else
				if (debug_mode) then writeln('Bad line =====>',line_of_file,'<====>',start_of_line);			

		End;{while}
		Close(Read_File);  {qconsole.log Log File}
		Close(Write_File);		
		Writeln(changes_made,' changes made');
	End {readfile_ok}		
	Else
	Begin
		Writeln('Input file doesn''t exist, execution aborted');
        Halt;
    End;

{--------------------------------------------------------------------}
{ SECTION 4 - Read (TMP) LOG FILE to determine Num-Players and stats }
{--------------------------------------------------------------------}
	Writeln('-----------------------------------------------');
	Writeln('Reading Quake-Log File:- ', temp_File_Name);
	Assign(Read_File,temp_File_Name);

     {$I-}   Reset(Read_File);   {$I+}
     Read_File_OK := (IOResult = 0);

     If (Read_File_OK) then
        BEGIN
		While not Eof(Read_File) Do
        BEGIN
        	Readln(Read_File, line_of_file);		{Get line}
			SimplifyDelimiters(line_of_file,' ');	{..clean it up..}
			SkipLeadingSpaces(line_of_file);
			DeleteTrailingSpaces(line_of_file);
			line_count := line_count+1;

			temp_string := Get_word(line_of_file, 1); {player name}
			DeleteTrailingSpaces(temp_string);	

			check_if_player_is_in_array(temp_string);
			if (debug_mode) then writeln(line_count);
			if (player_not_in_array) then
				begin
					if (debug_mode) then  writeln('New Player: ',temp_string);
					player_array[num_player].name := temp_string;
					num_player := num_player +1;
				end;

			if (debug_mode) then for i:= 1 to 8 do write(player_array[i].name,' ');
			{if (debug_mode) then readln;}

{OLD METHOD OF PLAYER-NAME DETERMINATION}	
{			temp_string := CONCAT(Get_word(line_of_file, 2), 
			           			  Get_word(line_of_file, 3),
			           			  Get_word(line_of_file, 4));
			if 	(temp_string='entered the game.') OR 
				(temp_string='entered the game') then
				Begin
					num_player := num_player + 1;
					temp_string := Get_word(line_of_file, 1);
					Remove_last_chars(temp_string,1);
					player_array[num_player].name := temp_string; 
				End;

			temp_string := CONCAT(Get_word(line_of_file, 4), 
			           			  Get_word(line_of_file, 5),
			           			  Get_word(line_of_file, 6));

			if (temp_string='entered the game.') then
				Begin
					num_player := num_player + 1;
					temp_string := Get_word(line_of_file, 1);
					Remove_last_chars(temp_string,1);
					player_array[num_player].name := temp_string; 
				End;	}

		End; {while}
		Close(Read_File);  {tmp.out Log File}
	End {readfile_ok}		
	Else
	Begin
		Writeln('Input file doesn''t exist, execution aborted');
        Halt;
    End;


{Print out Player names}
	if (debug_mode) then writeln;
	num_player := num_player -1;
		
	if (num_player=0) OR (num_player=-1) then	
		Begin
		Writeln('0 Players found?');
		Halt;
		End
	else
		Begin
			Writeln('Players found:');
			For i:= 1 to num_player Do	Writeln('              ',i,'. ',player_array[i].name);
		end;

	
{Re-Open Log file and start parsing}
		Reset(Read_File);

		While not Eof(Read_File) Do
        BEGIN
        	Readln(Read_File, line_of_file);		{Get line}
			SimplifyDelimiters(line_of_file,' ');	{..clean it up..}
			SkipLeadingSpaces(line_of_file);
			DeleteTrailingSpaces(line_of_file);
			line_count := line_count+1;

{Get Timing Info if present}
			If ( (Get_word(line_of_file,2)='joined ') AND 
			     (Get_word(line_of_file, 3)='at ') ) Then
				Begin
					times_found := TRUE;
					temp_string := Get_word(line_of_file,1);
					For i:= 1 to num_player DO
					Begin
						If (temp_string=player_array[i].name) then
							Begin
							temp_string := Get_word(line_of_file,4);
							VAL(temp_string, temp_int, conv_code);
							if (conv_code <> 0) then Writeln('Error: Getting Timing 1')
							else player_array[i].start := temp_int;
							End;
					End;{for}
				End;		

			If ( (Get_word(line_of_file,2)='left ') AND 
			     (Get_word(line_of_file, 3)='at ') ) Then
				Begin
					For j:= 1 to num_player Do
					Begin
						temp_string := Get_word(line_of_file,1);
						Remove_last_chars(temp_string,1);
						If (temp_string=player_array[j].name) Then
							Begin
								temp_string := Get_word(line_of_file,4);
								VAL(temp_string, temp_int, conv_code);	
								if (conv_code <> 0) then Writeln('Error: Getting Timing 2')
								else player_array[j].endtime := temp_int;
							End;
					End;{for}	
				End;{if}

{---------------------------------------------------------------------}
{ ---------------------------- DEATHS --------------------------------}
{ All these are basically the same and could easily be procedure-ised }
{---------------------------------------------------------------------}
{Message1: A Killed B type messages with 3middle words}

			temp_string := CONCAT(Get_word(line_of_file, 2),
									Get_word(line_of_file, 3),
									Get_word(line_of_file, 4)); 
		If (debug_mode) then Writeln('Before->',temp_String,'<-');	
			DeleteTrailingSpaces(temp_string);	
		If (debug_mode) then Writeln('After->',temp_String,'<-');	
			if (temp_string='was punctured by') OR
			   (temp_string='was nailed by') then
				Begin
				{	Writeln('Message1'); 	}
					victim_name := Get_word(line_of_file, 1);
					Remove_last_chars(victim_name,1);
					killer_name := Get_word(line_of_file, 5);
					temp_string := 'KILL';
					kill_type := 'N';
					Update_player_scores(temp_string,kill_type);
				End; {if}

			if (temp_string='was ax-murdered by')  then
				Begin
				{	Writeln('Message1'); 	}
					victim_name := Get_word(line_of_file, 1);
					Remove_last_chars(victim_name,1);
					killer_name := Get_word(line_of_file, 5);
					temp_string := 'KILL';
					kill_type := 'A';					
					Update_player_scores(temp_string, kill_type);
				End; {if}

			if (temp_string='was telefragged by') then
				Begin
				{	Writeln('Message1'); 	}
					victim_name := Get_word(line_of_file, 1);
					Remove_last_chars(victim_name,1);
					killer_name := Get_word(line_of_file, 5);
					temp_string := 'KILL';
					kill_type := 'T';					
					Update_player_scores(temp_string, kill_type);
				End; {if}

				
{Message2: A killed B type messages with split phrases Part1}
			temp_string := CONCAT(Get_word(line_of_file, 2),
									Get_word(line_of_file, 3),
									Get_word(line_of_file, 5)); 
			DeleteTrailingSpaces(temp_string);	
							
			if (temp_string='chewed on boomstick') then
				Begin
			{		Writeln('Message2'); }
					victim_name := Get_word(line_of_file, 1);
					Remove_last_chars(victim_name,1);
					killer_name := Get_word(line_of_file, 4);
					Remove_last_chars(killer_name,3);
					temp_string := 'KILL';
					kill_type := 'S';
					Update_player_scores(temp_string,kill_type);
				End;{if}
			
{Message3: A killed B type messages with split phrases Part2}
			temp_string := CONCAT(Get_word(line_of_file, 2),
									Get_word(line_of_file, 3),
									Get_word(line_of_file, 4),
									Get_word(line_of_file, 5),									
									Get_word(line_of_file, 7)); 
			DeleteTrailingSpaces(temp_string);	
			
			if (temp_string='ate 2 loads of buckshot') then
				Begin
				{	Writeln('Message3'); 	}
					victim_name := Get_word(line_of_file, 1);
					Remove_last_chars(victim_name,1);
					killer_name := Get_word(line_of_file, 6);
					Remove_last_chars(killer_name,3);
					temp_string := 'KILL';
					kill_type := 'S';
					Update_player_scores(temp_string,kill_type);
				End;{if}

{Message4: A killed B type messages with split phrases Part3}
			temp_string := CONCAT(Get_word(line_of_file, 2),
									Get_word(line_of_file, 3),
									Get_word(line_of_file, 4),
									Get_word(line_of_file, 6)); 
			DeleteTrailingSpaces(temp_string);	
			
			if (temp_string='was gibbed by grenade') OR
			   (temp_string='was gibbed by rocket') then
				Begin
					victim_name := Get_word(line_of_file, 1);
					Remove_last_chars(victim_name,1);
					killer_name := Get_word(line_of_file, 5);
					Remove_last_chars(killer_name,3);
					temp_string := 'KILL';
					kill_type := 'R';
					Update_player_scores(temp_string,kill_type);
				End;{if}

			if (temp_string='was gibbed by pipe')  then
				Begin
					victim_name := Get_word(line_of_file, 1);
					Remove_last_chars(victim_name,1);
					killer_name := Get_word(line_of_file, 5);
					Remove_last_chars(killer_name,3);
					temp_string := 'KILL';
					kill_type := 'P';
					Update_player_scores(temp_string,kill_type);
				End;{if}

				
{Message5: A killed B type messages with split phrases Part4}
			temp_string := CONCAT(Get_word(line_of_file, 2),
									Get_word(line_of_file, 4)); 
			DeleteTrailingSpaces(temp_string);	

			if (temp_string='eats pineapple') OR
			   (temp_string='rides rocket') then
				Begin
					victim_name := Get_word(line_of_file, 1);
					Remove_last_chars(victim_name,1);
					killer_name := Get_word(line_of_file, 3);
					Remove_last_chars(killer_name,3);
					temp_string := 'KILL';
					kill_type := 'R';
					Update_player_scores(temp_string,kill_type);
				End;{if}

			if (temp_string='accepts discharge') OR
			   (temp_string='accepts shaft') then
			   Begin
					victim_name := Get_word(line_of_file, 1);
					Remove_last_chars(victim_name,1);
					killer_name := Get_word(line_of_file, 3);
					Remove_last_chars(killer_name,3);
					temp_string := 'KILL';
					kill_type := 'L';
					Update_player_scores(temp_string,kill_type);
				End;{if}

			if (temp_string='smokes pipe') then
				Begin
			{		writeln(line_count, ': smokes pipe');	}
					victim_name := Get_word(line_of_file, 1);
					Remove_last_chars(victim_name,1);
					killer_name := Get_word(line_of_file, 3);
					Remove_last_chars(killer_name,3);
					temp_string := 'KILL';
					kill_type := 'P';
					Update_player_scores(temp_string,kill_type);
				End;{if}


{Message6: A killed B type messages with split phrases Part5}
{This one never happens so stuff it}
{			temp_string := CONCAT(Get_word(line_of_file, 1),
									Get_word(line_of_file, 2),
									Get_word(line_of_file, 3)); 

			if (temp_string='Satan''s power deflects') then
				Begin
					victim_name := Get_word(line_of_file, 4);
					Remove_last_chars(victim_name,1);

				
				End;  }

{---------------------------------------------------------------------}
{ -------------------------- SUICIDES --------------------------------}
{---------------------------------------------------------------------}
{Message7: A Killed A Suicide messages Part1}				
			temp_string := CONCAT(Get_word(line_of_file, 2),
									Get_word(line_of_file, 3),
									Get_word(line_of_file, 4),
									Get_word(line_of_file, 5)); 
			DeleteTrailingSpaces(temp_string);	

			if (temp_string='discharges into the water') OR
			   (temp_string='tries to put the') OR 
			   (temp_string='becomes bored with life') OR
			   (temp_string='checks if his weapon') OR
			   (temp_string='sleeps with the fishes') OR
   			   (temp_string='gulped a load of') OR			   
   			   (temp_string='can''t exist on slime') OR			      			   
   			   (temp_string='turned into hot slag') OR			 
   			   (temp_string='fell to his death') OR		
   			   (temp_string='blows himself to bits') then
				Begin
					killer_name := Get_word(line_of_file, 1);
					Remove_last_chars(killer_name,1);
					victim_name := killer_name;
					If (debug_mode) then Writeln(line_count, ': Suicide: ',killer_name,' ->',temp_String,'<-');
					temp_string := 'SUICIDE';
					Update_player_scores(temp_string,' ');
				End;{if}


{Message8: A Killed A Suicide messages Part2}				
			temp_string := CONCAT(Get_word(line_of_file, 2),
									Get_word(line_of_file, 3),
									Get_word(line_of_file, 4));
			DeleteTrailingSpaces(temp_string);	
			
			if (temp_string='sucks it down') OR
			   (temp_string='burst into flames') OR			   
			   (temp_string='ate a lavaball') OR			   
			   (temp_string='tried to leave') then
				Begin
				{	Writeln('Message8');	}
					killer_name := Get_word(line_of_file, 1);
					Remove_last_chars(killer_name,1);
					victim_name := killer_name;
					temp_string := 'SUICIDE';
					Update_player_scores(temp_string,' ');
				End;{if}

{Message9: A Killed A Suicide messages Part2}				
			temp_string := CONCAT(Get_word(line_of_file, 2),
									Get_word(line_of_file, 3),
									Get_word(line_of_file, 4));
			DeleteTrailingSpaces(temp_string);	
			
			if (temp_string='blew up') OR
			   (temp_string='was squished') OR			   
			   (temp_string='was spiked')  then
				Begin
				{	Writeln('Message9');}
					killer_name := Get_word(line_of_file, 1);
					Remove_last_chars(killer_name,1);
					victim_name := killer_name;
					temp_string := 'SUICIDE';
					Update_player_scores(temp_string,' ');
				End;{if}

{Message10: A Killed A Suicide messages Part2}				
			temp_string := Get_word(line_of_file, 2);
			DeleteTrailingSpaces(temp_string);	

			if (temp_string='died') then
				Begin
			{		Writeln('Message10');}
					killer_name := Get_word(line_of_file, 1);
					Remove_last_chars(killer_name,1);
					victim_name := killer_name;
					temp_string := 'SUICIDE';
					Update_player_scores(temp_string,' ');
				End;{if}


		End; {while}
		Close(Read_File);  {qconsole.log Log File}


{---------------------------------------------------------------------}
{ -----------------  CALCULATE/DISPLAY RESULTS -----------------------}
{---------------------------------------------------------------------}
	
		Writeln;
		If (times_found=FALSE) then Writeln('No extended timing info found...')
		else Writeln('Extended timing info being used....');
		Writeln;
		{Writeln(num_player,' players found');
		Writeln; }

		{Calculate some stats}
		For k:= 1 to num_player Do
		Begin
			player_array[k].rank := player_array[k].frags -  player_array[k].deaths;
			if ((((player_array[k].frags + player_array[k].deaths)) <> 0) ) then  	{check to prevent div by zero}
			player_array[k].eff  := ROUND( 100*(player_array[k].frags / 
										(player_array[k].frags + player_array[k].deaths) ));
		
			player_array[k].game_time := player_array[k].endtime - player_array[k].start;
			player_array[k].game_time_str := hours_mins_secs(player_array[k].game_time);
			if (times_found) then player_array[k].frags_min := 60 *(player_array[k].frags / player_array[k].game_time);
		End;{for}
		
		if (full_mode=FALSE) then
		Begin
			if (times_found) then		
				Writeln('Player               frags  deaths  suicides  rank   eff%   gametime  frags/minc')
			else
				Writeln('Player               frags  deaths  suicides  rank   eff%');
				
			For k:= 1 to num_player Do
			Begin
				if (times_found) then
					Writeln(player_array[k].name:15,player_array[k].frags:8,player_array[k].deaths:8,player_array[k].suicides:8,
	 						player_array[k].rank:8,player_array[k].eff:8,player_array[k].game_time_str:8,'  ',player_array[k].frags_min:4:1)
				else
					Writeln(player_array[k].name:15,player_array[k].frags:8,player_array[k].deaths:8,player_array[k].suicides:8,
	 						player_array[k].rank:8,player_array[k].eff:8);
			End;{for}
			Writeln;
		End;{full-mode}
		
{Write out the Frag-on-Frag summary Table}
		Writeln('        Victim');
		Writeln('Killer');
		Write(' ':12);
		For j:=1 to num_player Do Write(player_array[j].name:8);
		Writeln;
		For k:= 1 to num_player Do  {Rows}
			Begin
				Write(player_array[k].name:15);
				For j:= 1 to num_player Do	{Cols}
					Write(kill_death_array[k,j]:4,' ');
				Writeln;
			End;

		{Write out the Advanced stuff if required}
		if (full_mode) then
		Begin
			Writeln;
			For j:=1 to 22 Do
			Begin
				if (j<21) then
					Write(out_str[j])
				else {j=21 or 22}
					If (times_found) then Write(out_str[j]);
					
				For k:=1 to num_player Do
					case j Of
					1 : write(player_array[k].name,'  ');
					2 : write(player_array[k].frags:6);
					3 : write(player_array[k].deaths:6);
					4 : write(player_array[k].rank:6);
					5 : write(player_array[k].eff:6);
					6 : write(player_array[k].suicides:6);
					7 : write(player_array[k].axe_kill:6);
					8 : write(player_array[k].shot_kill:6);
					9 : write(player_array[k].nail_kill:6);
					10 : write(player_array[k].rock_kill:6);
					11 : write(player_array[k].light_kill:6);
					12 : write(player_array[k].tele_kill:6);
					13 : write(player_array[k].pipe_kill:6);
					14 : write(player_array[k].axe_death:6);
					15 : write(player_array[k].shot_death:6);
					16 : write(player_array[k].nail_death:6);
					17 : write(player_array[k].rock_death:6);
					18 : write(player_array[k].light_death:6);
					19 : write(player_array[k].tele_death:6);
					20 : write(player_array[k].pipe_death:6);
					21 : if (times_found) then write(player_array[k].game_time_str:8);
					22 : if (times_found) then write(player_array[k].frags_min:4:1);
					End;{case}

					if (j<21) then Writeln
					else {j=21 or 22}
						If (times_found) then Writeln;
					
			End;{for}
			Writeln;
		End;{if}
{--------------------- WRITE OUT COMMA_DELIMITED DATA HERE ------------------------}
{ This is to use data in a spreadsheet }
		if (comma_mode) then
		Begin
			Output_File_Name := CONCAT(basic_file_name,'dat');
            Writeln('Writing Comma-delimited Output File:- ', Output_File_Name);
            Assign(Write_File, Output_File_Name);
            Rewrite(Write_File);                {creates a new file}
  	     
			For k:=1 to num_player Do
			if (times_found) then
				Writeln(Write_File,player_array[k].name,',',player_array[k].frags,',',
					 player_array[k].deaths,',',player_array[k].rank,',',
					 player_array[k].eff,',',player_array[k].suicides,',',
					 player_array[k].axe_kill,',',player_array[k].shot_kill,',',
				 	 player_array[k].nail_kill,',',player_array[k].rock_kill,',',
				 	 player_array[k].light_kill,',',player_array[k].tele_kill,',',
				 	 player_array[k].pipe_kill,',',player_array[k].axe_death,',',
				  	 player_array[k].shot_death,',',player_array[k].nail_death,',',
				 	 player_array[k].rock_death,',',player_array[k].light_death,',',
				 	 player_array[k].tele_death,',',player_array[k].pipe_death,',',
				 	 player_array[k].game_time,',',player_array[k].frags_min:4:1)
			else
				Writeln(Write_File,player_array[k].name,',',player_array[k].frags,',',
					 player_array[k].deaths,',',player_array[k].rank,',',
					 player_array[k].eff,',',player_array[k].suicides,',',
					 player_array[k].axe_kill,',',player_array[k].shot_kill,',',
				 	 player_array[k].nail_kill,',',player_array[k].rock_kill,',',
				 	 player_array[k].light_kill,',',player_array[k].tele_kill,',',
				 	 player_array[k].pipe_kill,',',player_array[k].axe_death,',',
				  	 player_array[k].shot_death,',',player_array[k].nail_death,',',
				 	 player_array[k].rock_death,',',player_array[k].light_death,',',
				 	 player_array[k].tele_death,',',player_array[k].pipe_death );

            Close(Write_File);
		End; {if}


{------------------------------- WRITE OUT HTML FILE HERE ---------------------------}

		if (html_mode) then
		Begin
			Output_File_Name := CONCAT(basic_file_name,'htm');
            Writeln('Writing HTML Output File:- ', Output_File_Name);
            Assign(Write_File, Output_File_Name);
            Rewrite(Write_File);                {creates a new file}

		{Write-out the Header}
		    line_of_file :='<Body Background="qback1.gif" BGColor=#000000 Text=#FF80C0>';
            Writeln(Write_File, line_of_file);
            line_of_file := '<BR><CENTER>';
            Writeln(Write_File, line_of_file);
			Writeln(Write_File,'');				
            line_of_file := CONCAT('<H1>LEVEL/SERVER</H1><BR><BR><BR>');
            Writeln(Write_File, line_of_file);
			Writeln(Write_File,'');				

		{Write out the Frag-on-Frag Summary}
			line_of_file := '<H2>Frag on Frag Summary</H2>';
			Writeln(Write_File, line_of_file);
			line_of_file := '<TABLE BORDER=1 ALIGN=CENTER BGCOLOR=#000000>';
			Writeln(Write_File, line_of_file);
			Write(Write_File,'<TR><TH>');
			For j:=1 to num_player Do Write(Write_File,'<TH>',player_array[j].name);
			Writeln(Write_File,'</TR>');
			For k:= 1 to num_player Do  {Rows}
				Begin
					Write(Write_File,'<TR><TH>');
					Write(Write_File,player_array[k].name);
					For j:= 1 to num_player Do	{Cols}
						Write(Write_File,'<TH>',kill_death_array[k,j]);
					Writeln(Write_File,'</TR>');
				End;
			Writeln(Write_File,'</TABLE><BR><BR>');
			Writeln(Write_File,'');				
			Writeln(Write_File,'');

		{Write out more details as required}

		if (full_mode) then
		Begin
			line_of_file := '<H2>Player Summary</H2>';
			Writeln(Write_File, line_of_file);
			line_of_file := '<TABLE BORDER=1 ALIGN=CENTER BGCOLOR=#000000>';
			Writeln(Write_File, line_of_file);

			For j:=1 to 22 Do
			Begin
				if (j<21) then
					Write(Write_File,'<TR><TH>',out_str[j])
				else {j=21 or 22}
					If (times_found) then Write(Write_File,'<TR><TH>',out_str[j]);
					
				For k:=1 to num_player Do
					Begin
						case j Of
						1 : write(Write_File,'<TH>',player_array[k].name);
						2 : write(Write_File,'<TH>',player_array[k].frags);
						3 : write(Write_File,'<TH>',player_array[k].deaths);
						4 : write(Write_File,'<TH>',player_array[k].rank);
						5 : write(Write_File,'<TH>',player_array[k].eff);
						6 : write(Write_File,'<TH>',player_array[k].suicides);
						7 : write(Write_File,'<TH>',player_array[k].axe_kill);
						8 : write(Write_File,'<TH>',player_array[k].shot_kill);
						9 : write(Write_File,'<TH>',player_array[k].nail_kill);
						10 : write(Write_File,'<TH>',player_array[k].rock_kill);
						11 : write(Write_File,'<TH>',player_array[k].light_kill);
						12 : write(Write_File,'<TH>',player_array[k].tele_kill);
						13 : write(Write_File,'<TH>',player_array[k].pipe_kill);
						14 : write(Write_File,'<TH>',player_array[k].axe_death);
						15 : write(Write_File,'<TH>',player_array[k].shot_death);
						16 : write(Write_File,'<TH>',player_array[k].nail_death);
						17 : write(Write_File,'<TH>',player_array[k].rock_death);
						18 : write(Write_File,'<TH>',player_array[k].light_death);
						19 : write(Write_File,'<TH>',player_array[k].tele_death);
						20 : write(Write_File,'<TH>',player_array[k].pipe_death);
						21 : if (times_found) then 
								write(Write_File,'<TH>',player_array[k].game_time_str);
						22 : if (times_found) then 
								write(Write_File,'<TH>',player_array[k].frags_min:4:1);
						End;{case}

					if (k=num_player) then 
						if (j<21) then	{just print it}
							Writeln(Write_File,'</TR>')
						else {j=21 or 22}
							if (times_found) then
								Writeln(Write_File,'</TR>');
							
					End;{for k:=}
			End;{for j:=}

			Writeln(Write_File,'</TABLE><BR><BR>');
			Writeln(Write_File,'');				
			Writeln(Write_File,'');

		End
		Else {NOT full_mode i.e. basic mode}
		Begin
			line_of_file := '<H2>Player Summary</H2>';
			Writeln(Write_File, line_of_file);
			line_of_file := '<TABLE BORDER=1 ALIGN=CENTER BGCOLOR=#000000>';
			Writeln(Write_File, line_of_file);
			{Print the top line headings}
			if (times_found) then
				Writeln(Write_File, '<TR><TH>Player<TH>Frags<TH>Deaths<TH>Suicides<TH>Rank<TH>Efficiency%<TH>Game-Time<TH>Frags/min</TR>')
			else
				Writeln(Write_File, '<TR><TH>Player<TH>Frags<TH>Deaths<TH>Suicides<TH>Rank<TH>Efficiency%</TR>');
			
			Write(Write_File,'<TR><TH>');
			For k:= 1 to num_player Do
			Begin
				if (times_found) then
						Writeln(Write_File,'<TR><TH>',player_array[k].name,'<TH>',
							player_array[k].frags,'<TH>',player_array[k].deaths,'<TH>',
							player_array[k].suicides,'<TH>',player_array[k].rank,'<TH>',
							player_array[k].eff,'<TH>',player_array[k].game_time_str,'<TH>',
							player_array[k].frags_min:4:1,'</TR>')
				else
						Writeln(Write_File,'<TR><TH>',player_array[k].name,'<TH>',
							player_array[k].frags,'<TH>',player_array[k].deaths,'<TH>',
							player_array[k].suicides,'<TH>',player_array[k].rank,'<TH>',
							player_array[k].eff,'</TR>');
			End;{for}
			Writeln(Write_File,'</TABLE><BR><BR>');
			Writeln(Write_File,'');				
			Writeln(Write_File,'');

		End; {if full/not full mode}
		
		{Write out the Footer}
			Writeln(Write_file,'</CENTER>');

            Close(Write_File);			
		End;{if-html-mode}

END.
{-------------------------------------------EOF-----------------------------------------------}
